%define ALD_Ver		1.2.4

Name:         unzip

License:	Info-ZIP
Summary:	unzip - list, test and extract compressed files in a ZIP archive
Group:		System/Tools
Version:	6.0
Release:	0
URL: http://www.info-zip.org

Source: %{name}60.tar.xz
Source1: CROSS.sh
Source2: %{name}60-patches.tgz

%define DestDir		/System
# -----------------------------------------------------
%if %{_target_cpu} == %{_build_cpu}
%define _CROSS 0
%else
# rpm --target=x86_64/armv6l/armv7l/win32 -ba xxxxx.spec
%define _CROSS 1
%endif

%define TO_ARCH %{_target_cpu}

%if %{_target_cpu} == "armv6l"
%define ARM_ARCH armv6zk
%define ARM_FPU  -mfpu=vfp -mfloat-abi=hard
%define TO_ARCH %{ARM_ARCH}
%endif

%if %{_target_cpu} == "armv7l"
%define ARM_ARCH armv7-a
%define ARM_FPU  -mfpu=vfpv3-d16 -mfloat-abi=hard
%define TO_ARCH %{ARM_ARCH}
%endif

%define BUILD_TAR 1
#------------------ CROSS DIR --------------------
%if %{_CROSS}

%if %{_os} == "mingw"
ERROR: target=%{_os}
%else  #win32 || win64
%define target %{_arch}-%{_os}%{_gnu}
%endif

%define crossdir	/cross
%if %{_arch} == "arm"
%define csysdir		%{crossdir}/%{ARM_ARCH}
%else
%define csysdir		%{crossdir}/%{_target_cpu}
%endif
%define csysbindir	%{csysdir}/bin
%define target_  %{target}-

%define __os_install_post %{nil}

%define cross_prefix	%{csysdir}%{_prefix}
%define cross_bindir	%{csysdir}%{_bindir}
%define cross_sbindir	%{csysdir}%{_sbindir}
%define cross_libdir	%{csysdir}%{_libdir}
%define cross_includedir %{csysdir}%{_includedir}
%define cross_datadir	%{csysdir}%{_datadir}
%define cross_infodir	%{csysdir}%{_infodir}
%define cross_mandir	%{csysdir}%{_mandir}
%define cross_defaultdocdir %{csysdir}%{_defaultdocdir}
%define cross_docdir	%{cross_defaultdocdir}/%{name}

%define CrossDestDir	/Cross

%define _srcrpmdir	%{_topdir}/SRPMS/tmp

%else  #_CROSS

%define csysbindir	%{_prefix}/bin
%define CrossDestDir	%{nil}
%define _srcrpmdir	%{_topdir}/SRPMS/%{ALD_Ver}

%define target %{_build}
%define target_  %{nil}

%endif # !_CROSS

%define docdir %{_defaultdocdir}/%{name}
# ------------------- description ------------------------------------
%description
unzip - list, test and extract compressed files in a ZIP archive
# -------------------
%package tools
Summary:      unzip-6.0 tools  funzip, unzipsfx, zipgrep
Group:        System/Tools
%description tools
unzip-6.0 tools  funzip, unzipsfx, zipgrep

# ------------------- setup ------------------------------------------
%Prep
%setup -q -n %{name}60

tar -xaf %SOURCE2
patch -p1<patches/03-include-unistd-for-kfreebsd.patch
patch -p1<patches/04-handle-pkware-verification-bit.patch
patch -p1<patches/05-fix-uid-gid-handling.patch
patch -p1<patches/06-initialize-the-symlink-flag.patch
patch -p1<patches/07-increase-size-of-cfactorstr.patch
patch -p1<patches/08-allow-greater-hostver-values.patch
patch -p1<patches/09-cve-2014-8139-crc-overflow.patch
patch -p1<patches/10-cve-2014-8140-test-compr-eb.patch
patch -p1<patches/11-cve-2014-8141-getzip64data.patch
patch -p1<patches/12-cve-2014-9636-test-compr-eb.patch
patch -p1<patches/13-remove-build-date.patch
patch -p1<patches/14-cve-2015-7696.patch
patch -p1<patches/15-cve-2015-7697.patch
patch -p1<patches/16-fix-integer-underflow-csiz-decrypted.patch
patch -p1<patches/17-restore-unix-timestamps-accurately.patch
patch -p1<patches/18-cve-2014-9913-unzip-buffer-overflow.patch
patch -p1<patches/19-cve-2016-9844-zipinfo-buffer-overflow.patch



# ------------------- Build ------------------------------------------
%Build
%if %{_CROSS}
PATH=%{csysbindir}:$PATH:/opt/perl/bin
GCC_NoHostPath=d
export PATH GCC_NoHostPath
%else
export PATH=$PATH:/opt/perl/bin
%endif

GCC_VER_STR=`%{target_}gcc -dumpversion`
LDFLAGS=" "

%if %{_arch} == "i386"
OPTFLAGS="-Os -march=i486 -mpreferred-stack-boundary=2 -falign-functions=1 -falign-jumps=1 -falign-loops=1 -fomit-frame-pointer"
OPT47=`case $GCC_VER_STR in 4.[789].*) echo "-fno-asynchronous-unwind-tables" ;; esac`
%endif
%if %{_arch} == "x86_64"
OPTFLAGS="-Os"
OPT47=`case $GCC_VER_STR in 4.[789].*) echo "-fno-asynchronous-unwind-tables" ;; esac`
LDFLAGS=`case $GCC_VER_STR in 4.[56789].*) echo -static-libgcc ;; esac`
%endif
%if %{_arch} == "arm"
OPTFLAGS="-Os -march=%{ARM_ARCH} %{ARM_FPU} -munaligned-access"
OPT47=
%endif

CFLAGS="$OPTFLAGS $OPT47 -ffunction-sections -fdata-sections -std=gnu99 -D_GNU_SOURCE -Wall"
LDFLAGS="-Wl,--gc-sections"
CC="%{target_}gcc"

sed -i s:"-O3":"$CFLAGS": unix/configure
sed -i s:"LFLAGS1=\"\"":"LFLAGS1=\"$LDFLAGS\"": unix/configure
sed -i s:"\$(L_BZ2)":"-lbz2": unix/Makefile

make -f unix/Makefile generic CC="$CC" D_USE_BZ2="-DUSE_BZIP2" &>FMake_log.txt

# ------------------- Install ----------------------------------------
%Install
%if %{_CROSS}
PATH=%{csysbindir}:$PATH
GCC_NoHostPath=d
export PATH GCC_NoHostPath
%endif

rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
mkdir -p %{_srcrpmdir}
mkdir -p $RPM_BUILD_ROOT%{docdir}

make -f unix/Makefile install prefix=$RPM_BUILD_ROOT%{_prefix} &>FInstall_log.txt
mv $RPM_BUILD_ROOT%{_prefix}/man $RPM_BUILD_ROOT%{_datadir}/

cp LICENSE README $RPM_BUILD_ROOT%{docdir}/

pushd $RPM_BUILD_ROOT%{_bindir}
  rm -f zipinfo
  ln -s unzip zipinfo
popd

%if %{_CROSS}
TARGET_PRFIX=%{_prefix}
TARGET_CROSS_PRFIX=%{csysdir}
TARGET_NAME=%{target}
MKCROSSDIR=0
export TARGET_PRFIX TARGET_CROSS_PRFIX TARGET_NAME MKCROSSDIR
%SOURCE1
%endif #_CROSS

%if !%{_CROSS}
if test -f /opt/aldccp/bin/packages_idx; then
  /opt/aldccp/bin/packages_idx -p %{name} -v %{version} -r %{DestDir} $RPM_BUILD_ROOT
fi
%endif

# ------------------- Clean ------------------------------------------
%Clean
DE=%{version}-%{release}.%{TO_ARCH}.rpm
DD=%{_rpmdir}/%{TO_ARCH}/%{ALD_Ver}%{DestDir}

pushd %{_rpmdir}/%{_target_cpu}
  SE=%{version}-%{release}.%{_target_cpu}.rpm
  mkdir -p $DD
  mv %{name}-$SE $DD/%{name}-$DE
  mv %{name}-tools-$SE $DD/%{name}-tools-$DE
popd

# --------------- build *.tgz ------------------------
%if %{BUILD_TAR}
pushd $RPM_BUILD_ROOT
  TMP_TO=$DD/tar
  mkdir -p $TMP_TO
  tmp=%{name}-%{version}-%{release}.%{TO_ARCH}
  mkdir -p $tmp
  cp -r usr $tmp/
  tar -cjf $tmp.tar.bz2 $tmp
  mv $tmp.tar.bz2 $TMP_TO
  rm -r $tmp
popd
%endif  #BUILD_TAR

# ------------------- Files ------------------------------------------
%files
%{_bindir}/unzip
%{_bindir}/zipinfo
%{_mandir}/man1/unzip.1.gz
%{_mandir}/man1/zipinfo.1.gz
%{docdir}

%files tools
%{_bindir}/funzip
%{_bindir}/unzipsfx
%{_bindir}/zipgrep
%{_mandir}/man1/funzip.1.gz
%{_mandir}/man1/unzipsfx.1.gz
%{_mandir}/man1/zipgrep.1.gz
